#include <math.h>
#include "Reverb.h"

Reverb::Reverb(){
    int i,j;
    for (i=0;i<REV_COMBS*2;i++) {
	comblen[i]=32000;
	combk[i]=0;
	comb[i]=new REALTYPE[comblen[i]];
	for (j=0;j<comblen[i];j++) {
	    comb[i][j]=0;
	};
    };
};


Reverb::~Reverb(){
    int i;
    for (i=0;i<REV_COMBS*2;i++) delete comb[i];
};

void Reverb::revout(int size, REALTYPE *smps_l, REALTYPE *smps_r){
    int i;
    REALTYPE out;
    for (i=0;i<size;i++){
	out=smps_l[i]-comb[0][combk[0]]*0.4;
	comb[0][combk[0]]=out;
	smps_l[i]=out;
	
	combk[0]++;
	if (combk[0]>comblen[0]) combk[0]=0;
    };
};

