#include "MidiParser.h"
#include <stdio.h>

MidiParser::MidiParser(){
    int i;
    lastmidicmd=0;
    cmdtype=0;
    cmdchan=0;
    for (i=0;i<MP_MAX_BYTES;i++) cmdparams[i]=0;
    input=new OSSmidiin();
};

MidiParser::~MidiParser(){
};

void MidiParser::getmidicmd(MidiCmdType cmdtype,unsigned char cmdchan,unsigned char *cmdparams){
    unsigned char tmp,i;
    i=0;
    if (lastmidicmd==0){//asteapta prima data pana cand vine prima comanda midi
	while (tmp<0x80) tmp=input->getmidibyte();
	lastmidicmd=tmp;
	};

    tmp=input->getmidibyte();

    if (tmp>0x80) {
	lastmidicmd=tmp;
	tmp=input->getmidibyte();
	};

    if ((lastmidicmd>=0x80)&&(lastmidicmd<=0x8f)){//Note OFF
	cmdtype=MidiNoteOFF;
	cmdchan=lastmidicmd && 0x0f;
	cmdparams[0]=tmp;//note number
    };

    if ((lastmidicmd>=0x90)&&(lastmidicmd<=0x9f)){//Note ON
	cmdtype=MidiNoteON;
	cmdchan=lastmidicmd && 0x0f;
	cmdparams[0]=tmp;//note number	
	cmdparams[1]=input->getmidibyte();//velocity
	if (cmdparams[1]==0) cmdtype=MidiNoteOFF;//if velocity==0 then is note off
	printf("* %d *",lastmidicmd);fflush(stdout);
    };
        
};



