#include "../Input/OSSmidiin.h"

#define MP_MAX_BYTES 4000  //in case of loooong SYS_EXes
enum MidiCmdType{MidiNoteOFF,MidiNoteON};

class MidiParser{
    public:
	MidiParser();
	~MidiParser();
	void getmidicmd(MidiCmdType cmdtype,unsigned char cmdchan,unsigned char *cmdparams);
	unsigned char cmdtype;//tipul comenzii (noteon,noteof,sysex..)
	unsigned char cmdchan;//canalul pe care se aplica comanda [1..16]
	unsigned char cmdparams[MP_MAX_BYTES];//parametrii comenzii

    private:
	unsigned char lastmidicmd;//ultimul byte >= 0x80 receptionat de la midi
	OSSmidiin *input;
};

