#include "../globals.h"

#define MAX_ENVELOPE_POINTS 5
#define MIN_ENVELOPE_DB -60

class EnvelopeParams{
    public:
	EnvelopeParams();
	~EnvelopeParams();
	void ADSRinit(char A_dt,char D_dt,char S_val,char R_dt);
	void ADSRinit_dB(char A_dt,char D_dt,char S_val,char R_dt);
	void ASRinit(char A_val,char A_dt,char R_val,char R_dt);
	void ADSRinit_filter(char A_val,char A_dt,char D_val,char D_dt,char R_dt,char R_val);

       /* Parametrii MIDI */
	char Penvpoints;
	char Penvsustain;//127 pentru dezactivat
    	char Penvdt[MAX_ENVELOPE_POINTS];
	char Penvval[MAX_ENVELOPE_POINTS];
	
	//aici sa bag parametrul % stretch, adica cat este lungit Env. in functie de nota  si nota centru (unde nu este lungit/scurtat)

       /* Parametrii reali */
	REALTYPE envdt[MAX_ENVELOPE_POINTS];
	REALTYPE envval[MAX_ENVELOPE_POINTS];

    private:
	void midi2real();
	int Changed;//zero daca nu s-a modificat nici un parametru MIDI
		    //1 pentru parametrii ADSR (amplitudine liniara)
		    //2 pentru parametrii ADSR_dB (parametrii in dB)
		    //3 pentru paramtrii ASR (parametrii de frecventa)
		    //4 pentru parametrii ADSE_filter (parametrii de filtru)
	
};


