#include "../globals.h"
#include "../Params/FilterParams.h"

class Filter{
 public:
    Filter(FilterParams *filterpars);
    ~Filter();	
    void filterout(REALTYPE *smp);
    
    void setfreq(REALTYPE frequency);
 private:
    void computefiltercoefs();
    int type;//tipul filtrului (LPF,HPF)
    REALTYPE freq;//frecventa in Hz
    REALTYPE q; //rezonanta sau largimea de banda
    
    int order;//ordinul filtrului (1,2,4..)

    REALTYPE c0,c1,c2,d1,d2;//coeficientii
    REALTYPE x1,x2,y1,y2;//x1=x[n-1],x2[n-2]
};


