#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#include <unistd.h>
#include <pthread.h>

#include "Synth/ADnote.h"

ADnote *notes[127];
ADnoteParameters *testpar;


unsigned char note,vel,cmd;
FILE *seq;

unsigned char getmidi(){
    unsigned char b;
    b=1;
    while (b!=5){
	b=getc(seq);
	};
    return (getc(seq));
    
};

void *thread1(void *arg){
    unsigned char midibyte;
    cmd=0;
  while (1){
    midibyte=getmidi();
    if (midibyte>127) cmd=midibyte;
    note=0;
    if (cmd==254) continue;
	      if (cmd==144) {
	    if (midibyte==144) note=getmidi();
		    else note=midibyte;
	    vel=getmidi(); 
      };
    if (note!=0){
	fprintf(stderr,"%d %d \n",note,vel);
	if (notes[note]==NULL) notes[note]=new ADnote (testpar,note,vel/127.0);
	if ((notes[note]!=NULL)&&(vel==0)) notes[note]->relasekey();
    };
  };
};

void *thread2(void *arg){
    short int x,i;
    REALTYPE xx;
    REALTYPE smps[SOUND_BUFFER_SIZE];
    REALTYPE output[SOUND_BUFFER_SIZE];

    while (1){
    	    for (i=0;i<SOUND_BUFFER_SIZE;i++) output[i]=0.0;
    
	for (i=0;i<127;i++)
	    if (notes[i]!=NULL) {
		notes[i]->noteout(&smps[0]);
		for (x=0;x<SOUND_BUFFER_SIZE;x++) output[x]+=smps[x];
		if (notes[i]->finished()!=0) {
			delete(notes[i]);
			notes[i]=NULL;
		    };
		};

    	    for (i=0;i<SOUND_BUFFER_SIZE;i++){
		xx=-output[i]/NUM_VOICES*32768/4;
		if (xx<-32768) xx=-32768;
		if (xx>32767) xx=32767;
		x=(short int) xx;
		fwrite(&x,2,1,stdout);
		fwrite(&x,2,1,stdout);//pt. esdcat
		};
	};
};


main(){
    pthread_t thr1,thr2;
    int i;
    
    srand(time(NULL));
    testpar=new ADnoteParameters ();
    for (i=0;i<127;i++){
	notes[i]=NULL;
    };
    seq=fopen("/dev/sequencer","r");

    pthread_create(&thr1,NULL,thread1,NULL);
    pthread_create(&thr2,NULL,thread2,NULL);
        

    while (1){};    
//    testnote->relasekey();
//    fprintf(stderr,"%d ",pid);
    
};



