#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include "ADnote.h"
#include "globals.h"


ADnote::ADnote(int note,REALTYPE velocity){
  int i,noscil;
    ADnote::note=note;  
    ADnote::velocity=velocity;  
    time=0;
    for (noscil=0;noscil<NUM_VOICES;noscil++){
        oscposhi[noscil]=0;oscposlo[noscil]=0.0;
	ADnote::setfreq(noscil,440);//test
    	detune[noscil]=noscil*10.0;
	oscilsmp[noscil]=new REALTYPE[OSCIL_SIZE];//ATENTIE, trebuie modificat, in functie de ce este activat/dezactivat
	vibrattoint[noscil]=0.0;//fara vibratto
        //tests
        oscposhi[noscil]=rand() % OSCIL_SIZE;//!!!!!!!!!!!!!test
        for (i=0;i<OSCIL_SIZE;i++) oscilsmp[noscil][i]=14000*sin(i*6.28/OSCIL_SIZE/2-1.5)+14000*sin(i*6.28/OSCIL_SIZE*2);//test
    //  for (i=0;i<OSCIL_SIZE;i++) oscilsmp[i][noscil]=100.0*(i-OSCIL_SIZE/2.0);//test
	vibrattoint[noscil]=10.0;//test
	vibrattophase[noscil]=rand()%100;//test
	vibrattofreq[noscil]=0.5+rand()%100/100.0;//test
	
	glissandoenabled[noscil]=1;//test
	glissandoint[noscil]=rand()%10-9;//test
	glissandotime[noscil]=0.2;//test
  };

    ADnote::initparameters();
};

ADnote::~ADnote(){//dupa relase
  delete (oscilsmp);
};


void ADnote::initparameters(){//cad trece de la parametrii la RT
    int noscil;
    for (noscil=0;noscil<NUM_VOICES;noscil++){
	vibrattoincrement[noscil]=vibrattofreq[noscil]*2.0*PI/(REALTYPE)SAMPLE_RATE*(REALTYPE)SOUND_BUFFER_SIZE;
    };
};



void ADnote::setfreq(int noscil,REALTYPE freq){
    REALTYPE speed;
//aici calculez vibratto,si toti parametrii
    freq=fabs(freq);
    speed=freq*REALTYPE(OSCIL_SIZE)/(REALTYPE) SAMPLE_RATE;
    oscfreqhi[noscil]=(unsigned short int) floor(speed);
    oscfreqlo[noscil]=speed-floor(speed);
};


void ADnote::computecurrentparameters(){
    int noscil;
    REALTYPE freq,vib,gliss;
    for (noscil=0;noscil<NUM_VOICES;noscil++){
	vib=vibrattoint[noscil]*sin(vibrattophase[noscil]);vibrattophase[noscil]+=vibrattoincrement[noscil];
	if (glissandoenabled[noscil]!=0) {
	    gliss=glissandoint[noscil]*(1-(time/glissandotime[noscil]));
	    if (time>glissandotime[noscil]) glissandoenabled[noscil]=0;
	} else gliss=0;
	freq=exp(LOG_2*(note-57.0+gliss+(vib+detune[noscil])/100)/12)*440;
//	fprintf(stderr,"%f ",vibrattoincrement[noscil]);
	setfreq(noscil,freq);
    };
    time+=(REALTYPE)SOUND_BUFFER_SIZE/(REALTYPE)SAMPLE_RATE;
};


void ADnote::noteout(REALTYPE *out){
  int i,noscil;
  unsigned short int oscposhi2;

  for (i=0;i<SOUND_BUFFER_SIZE;i++) out[i]=0;
  ADnote::computecurrentparameters();    
  for (noscil=0;noscil<NUM_VOICES;noscil++){
    //VERIFIC DACA OSCILATORUL ESTE ACTIV!!!!!!!!!!!!!!!!
    //!!!!!!!!!!!!!!!!!!!!!!!!!!!
      for (i=0;i<SOUND_BUFFER_SIZE;i++){
        oscposhi2=oscposhi[noscil]+1; if (oscposhi2>OSCIL_SIZE) oscposhi2-=OSCIL_SIZE;
	//linia urmatoare poate sa scada f. mult polifonia x[y[z]]???
        out[i]+=oscilsmp[noscil][oscposhi[noscil]]*(1-oscposlo[noscil])+oscilsmp[noscil][oscposhi2]*oscposlo[noscil];
        oscposlo[noscil]+=oscfreqlo[noscil];
        if (oscposlo[noscil]>=1.0) {
    		oscposlo[noscil]-=1.0;	
		oscposhi[noscil]++;
	    };
        oscposhi[noscil]+=oscfreqhi[noscil];    
	if (oscposhi[noscil]>=OSCIL_SIZE) oscposhi[noscil]-=OSCIL_SIZE;
	
	
	//aici proceses "oscil-ul"(filtre,si alte kestii)
      };
  };
};






