#include "globals.h"

//Globals
//marimea unei forme de unda (la oscil) - putere al lui 2
#define OSCIL_SIZE 512


class ADnote{   //ADditive voice
 public:
  ADnote(int note,REALTYPE velocity);  
  ~ADnote();
  void noteout(REALTYPE *out); //trimite in tabloul *out sunetul de marimea sndbufsize
 private:
  void setfreq(int noscil,REALTYPE freq);
  void ADnote::computecurrentparameters();
  void ADnote::initparameters();
  //GLOBAL
    int note;
    REALTYPE velocity;     //frecventa de BAZA (fara vibratto...)
    REALTYPE time;//durata de cand suna nota
  //Pentru fiecare oscilator
    REALTYPE detune[NUM_VOICES];//(se masoara in centi)frecventa de baza a fiecarui oscilator = basefreq*detune
    REALTYPE volume[NUM_VOICES];
    REALTYPE *oscilsmp[NUM_VOICES];    //forma de unda
    REALTYPE vibrattoint[NUM_VOICES]; //(se masoara in centi) intensitatea vibratto 
    REALTYPE vibrattophase[NUM_VOICES];//de unde incepe vibratto
    int glissandoenabled[NUM_VOICES];
    REALTYPE glissandoint[NUM_VOICES];//intensitatea glissando-ului(poate fi si negativ)
    REALTYPE glissandotime[NUM_VOICES];//durata glissando-ului
  
  
  //PARAMETRII (NON REALTIME)!!!!!!!!nu sunt necesari in timpul sunetului
    REALTYPE vibrattofreq[NUM_VOICES];//frecventa in Hz a par. vibratto    
  //REALTIME!!!!!!!!! sunt necesari doar cand suna
    float oscposlo[NUM_VOICES],oscfreqlo[NUM_VOICES];    //partea factionara a pozitiei,skip(freq)
    unsigned short int oscposhi[NUM_VOICES],oscfreqhi[NUM_VOICES];//partea intreaga a pozitiei,skip(freq)
    REALTYPE vibrattoincrement[NUM_VOICES];//vibrattox[]+=vibrattoinc[]
};

