#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys/soundcard.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <unistd.h>

#include "OSSaudiooutput.h"

OSSaudiooutput::OSSaudiooutput(){
//    int snd_bufsize=SOUND_BUFFER_SIZE;
    int i;
    int snd_bitsize=16;
//    snd_fragment=0x000C000D;//fragment size ?????????   12 fragmente a cate 8
    snd_fragment=0x00080009;//fragment size ????????? 
    snd_stereo=1;//stereo
    snd_format=AFMT_S16_LE;
    snd_samplerate=SAMPLE_RATE;
    
    smps=new short int[SOUND_BUFFER_SIZE*2];
    for (i=0;i<SOUND_BUFFER_SIZE*2;i++) smps[i]=0;
        
    snd_handle=open("/dev/dsp",O_WRONLY,0);
    if (snd_handle == -1) {
	fprintf(stderr,"ERROR - I can't open the /dev/dsp.");
	exit(1);//INCORECT!!!!!!!!
	};
    
    ioctl(snd_handle,SNDCTL_DSP_RESET,NULL);

    ioctl(snd_handle,SNDCTL_DSP_SETFMT,&snd_format);
    ioctl(snd_handle,SNDCTL_DSP_STEREO,&snd_stereo);
    ioctl(snd_handle,SNDCTL_DSP_SPEED,&snd_samplerate);
    ioctl(snd_handle,SNDCTL_DSP_SAMPLESIZE,&snd_bitsize);
    ioctl(snd_handle,SNDCTL_DSP_SETFRAGMENT,&snd_fragment);
        
};


void OSSaudiooutput::OSSout(REALTYPE *smp_left,REALTYPE *smp_right){
    int i;
    REALTYPE l,r;
    for (i=0;i<SOUND_BUFFER_SIZE;i++){
	l=smp_left[i];
	r=smp_right[i];
	
	if (l<-1.0) l=-1.0; else if (l>1.0) l=1.0;
	if (r<-1.0) r=-1.0; else if (r>1.0) r=1.0;
	
	smps[i*2]=(short int) (l*32767.0);    
	smps[i*2+1]=(short int) (r*32767.0);
    };
    write(snd_handle,smps,SOUND_BUFFER_SIZE*4);// *2 pt. ca-i pe 16 biti, si inca o data * 2 pt. ca este stereo
};


OSSaudiooutput::~OSSaudiooutput(){
    close(snd_handle);
    delete(smps);
};
