#include <math.h>
#include "../globals.h"
#include "LFOParams.h"

LFOParams::LFOParams(char Pfreq_,char Pintensity_,char Pstartphase_, char PLFOtype_,char Prandomness_, char Pdelay_,char fel_){
    Pfreq=Pfreq_;
    Pintensity=Pintensity_;
    Pstartphase=Pstartphase_;
    PLFOtype=PLFOtype_;
    Prandomness=Prandomness_;
    Pdelay=Pdelay_;
    fel=fel_;
    
    LFOmidi2par_all();
};

LFOParams::~LFOParams(){
};

void LFOParams::LFOmidi2par_all(){
    switch (fel) {
	case 1:intensity=(REALTYPE) Pintensity/127.0;break;
	case 2:intensity=(REALTYPE) Pintensity/127.0*4.0;break;//in octave
	default:intensity=exp((REALTYPE) Pintensity/127.0*LOG_2*11.0)-1.0;//in centi
	
    };
    freq=exp(((REALTYPE) Pfreq/127.0*LOG_2*10.0)-1.0)/5.0;
    startphase=(REALTYPE) Pstartphase/127.0;
    randomness=(REALTYPE) Prandomness/127.0;
    delay=(REALTYPE) Pdelay*50.0;//de la 0 ms la 6350 ms
};

