#include <math.h>
#include "../globals.h"
#include "../Params/EnvelopeParams.h"


//cu cat se incrementeaza timpul la fiecare apelare al Envelope->envout();
#define INCT (REALTYPE)SOUND_BUFFER_SIZE/(REALTYPE)SAMPLE_RATE*1000.0


class Envelope{
public:
    Envelope(EnvelopeParams *envpars);
    ~Envelope();
    void relasekey();
    REALTYPE envout();
    REALTYPE envout_dB();
    int finished();//returneaza 1 daca s-a terminat
private:
    //parametrii
    int envpoints;
    int envsustain;//"-1" pentru dezactivat
    REALTYPE envdt[MAX_ENVELOPE_POINTS];//se masoara in milisecunde!!
    REALTYPE envval[MAX_ENVELOPE_POINTS];//valori [0..1]
    REALTYPE envstretch; //cat este "intins" in functie de frecventa notei (util la pian)    
    //valorile interne
    int currentpoint; //punctul curent (se incepe de la 1)
    char keyrelased; //daca am ridicat degetul de pe clapa(se trece de sustain)    
    char envfinish; //s-a terminat envelop-ul    
    REALTYPE t;//timpul scurs de la inceputul fiecarui punct    
};


