//rata de esantionare
#define SAMPLE_RATE 44100   

/*marimea unui buffer de sunet, intr-un sigur buffer nu are loc 
nici o modificare a parametrilor de sunet (frecventa,filtru)
este folosite peste tot in program(si la ADditve si SUBstractive)
Latenta poate fi numai multiplu al acesti valori. Toate transferurile se fac 
cu buffer-e de aceasta marime
Este cea mai importanta constanta si se masoara in esantioane(samples)*/
//SE MAI NUMESTE SI "GRANULARITY"!!!!!!!!!!!
#define SOUND_BUFFER_SIZE 200


//ce tip sa folosec in loc de float(pentru sunet...)
#define REALTYPE float

//numarul de canale(adica PARTS) MIDI
#define N_MIDI_PARTS 16

//polifonia unei singure note(cate voci exita pentru o singura nota muzicala)
#define NUM_VOICES 4

//polifonia in numarul de note
//#define POLIPHONY 32

//logaritm din 2
#define LOG_2 0.693147181

//PI
#define PI 3.1415926536

//ln 10
#define LOG_10 2.302585093

//Pragul de unde se interpoleaza amplitudinea (daca este mai mic, nu se interpoleaza)
#define AMPLITUDE_INTERPOLATION_THRESHOLD 0.0001

// dB2liniar
#define dB2rap(dB) (exp(dB*LOG_10/20.0))

//liniar2dB
#define rap2dB(rap) (20*ln(rap)/LOG_10)

//Random
#define RND (rand()/(RAND_MAX+1.0))


